#include <time.h>

#include <vector>
#include <map>

using std::vector;
using std::map;

#include "connection.hh"
#include "protocols.hh"
#include "stdin.hh"

class ConnectionCache
{
    struct ConnRec
    {
        Connection Conn;
        time_t     LastTouch;
        bool       Expiring;
    };
    vector<struct ConnRec> recs;
    map<Connection, unsigned> key2rec;
    
    struct StdinType *owner;
    
public:
    ConnectionCache(struct StdinType *o);
    ~ConnectionCache();
    
    /* Deletes a connection and sends a message. */
    void DeleteConnectionID(unsigned ConnID);
    
    /* Finds a connection entry or creates one and sends a message. */
    unsigned GetConnectionID(const Connection &conn, SockProtocol proto);
    
    /* Finds a connection and modifies the LastTouch date. */
    const Connection &GetConnection(unsigned ConnID);
};
